from pathlib import Path

from setuptools import find_packages, setup

with Path("requirements.txt").open() as f:
    requirements = f.read()
requirements = requirements.splitlines()

with Path("README.md").open(encoding="utf-8") as f:
    readme = f.read()
readme = "\n".join(readme.split("\n")[2:])

packages = find_packages()

with Path("bluequbit/version.py").open() as f:
    Version = f.read()

Version = Version.rstrip()
Version = Version[15:-1]

setup(
    name="bluequbit",
    version=Version,
    description="Python SDK to BlueQubit app",
    license="Apache 2.0",
    author="BlueQubit",
    author_email="hovnatan@bluequbit.io",
    long_description=readme,
    long_description_content_type="text/markdown",
    install_requires=requirements,
    packages=find_packages(exclude=("tests",)),
    python_requires=">=3.7",
)
